<?php

namespace NoccyLabs\Chrononaut\Calendar;

use NoccyLabs\Chrononaut\Date;
use IteratorAggregate;
use ArrayIterator;

class Month implements IteratorAggregate
{
    private $year;

    private $month;

    private $firstOfMonth;

    private $lastOfMonth;

    public function __construct(int $year=null, int $month=null)
    {
        $this->year = $year ?: intval(date("Y"));
        $this->month = $month ?: intval(date("m"));

        $this->firstOfMonth = Date::createFromFormat(
            "Y-m-d", 
            sprintf("%04d-%02d-%02d", $this->year, $this->month, 1)
        );
        $this->lastOfMonth = clone $this->firstOfMonth;
        $this->lastOfMonth->modify("+1 month")->modify("-1 day");
    }

    public function getWeeks()
    {
        $weeks = [];
        $firstWeek = $this->firstOfMonth->format("W");
        $lastWeek = $this->lastOfMonth->format("W");
        for ($week = $firstWeek; $week <= $lastWeek; $week++) {
            $weeks[$week] = new Week($this->year, $week);
        }
        return $weeks;
    }
    
    public function getIterator()
    {
        return new ArrayIterator($this->getWeeks());
    }
}