<?php

namespace NoccyLabs\Chrononaut\Calendar;

use NoccyLabs\Chrononaut\Date;
use DateTime;
use IteratorAggregate;
use ArrayIterator;

class Week implements IteratorAggregate
{
    private $year;

    private $week;

    private $firstOfWeek;

    private $lastOfWeek;

    public function __construct(int $year, int $week)
    {
        $this->year = $year;
        $this->week = $week;

        $this->firstOfWeek = new Date();
        $this->firstOfWeek->setISODate($year, $week);
        $this->lastOfWeek = clone $this->firstOfWeek;
        $this->lastOfWeek->modify("+6 days");
    }

    public function getDays()
    {
        $days = [];
        $day = clone $this->firstOfWeek;
        while ($day <= $this->lastOfWeek) {
            $days[] = clone $day;
            $day->modify("+1 day");
        }
        return $days;
    }

    public function getIterator()
    {
        return new ArrayIterator($this->getDays());
    }
    
}