<?php

namespace NoccyLabs\Chrononaut\Calendar;

use IteratorAggregate;
use ArrayIterator;

class Year implements IteratorAggregate
{
    private $year;

    public function __construct(int $year=null)
    {
        $this->year = $year ?: intval(date("Y"));
    }

    public function getMonth(int $month)
    {
        return new Month($year, $month);
    }

    public function getMonths(): array
    {
        $months = [];
        for($month = 1; $month <= 12; $month++) {
            $months[$month] = new Month($this->year, $month);
        }
        return $months;
    }

    public function getIterator()
    {
        return new ArrayIterator($this->getMonths());
    }
}