<?php

namespace NoccyLabs\Chrononaut;

use Iterator;
use ArrayAccess;
use DateTime;

class Date extends DateTime
{

    public function __construct(string $when = "now")
    {
        parent::__construct($when);
        $this->setTime(0, 0, 0);
    }

    public function addDays(int $days, int $months = null, int $years = null)
    {
        if ($days) $this->modify("{$days} days");
        if ($months) $this->modify("{$months} months");
        if ($years) $this->modify("{$years} years");
        return $this;
    }

    public function subtractDays(int $days, int $months = null, int $years = null)
    {
        if ($days) $this->modify("-{$days} days");
        if ($months) $this->modify("-{$months} months");
        if ($years) $this->modify("-{$years} years");
        return $this;
    }

    public function diffDays(Date $date): int
    {
        $diff = $this->diff($date);
        return $diff->days;
    }

    public function getWeekNumber(): int
    {
        return (int)$this->format("W");
    }

    public function getWeekday(): int
    {
        return (int)$this->format("N");
    }

    public function getNextDay(): Date
    {
        return (clone $this)->modify("+1 day");
    }

    public function getIsWeekend(): bool
    {
        return ($this->format("w") >= 5);
    
    }

    public function getDay(): int
    {
        return $this->format("d");
    }


    public function __toString()
    {
        return $this->format("Y-m-d");
    }
}
