<?php

namespace NoccyLabs\Chrononaut;

class DateTest extends \PhpUnit\Framework\TestCase
{

    public function setup()
    { }

    public function teardown()
    { }

    public function testCreating()
    {
        $date = new Date("2019-01-01");

        $this->assertEquals("2019-01-01", $date);
    }

    public function testAddingDaysMonthsAndYears()
    {
        $date = new Date("2019-01-01");

        $nextDay = new Date("2019-01-02");
        $nextMonth = new Date("2019-02-01");
        $nextYear = new Date("2020-01-01");
        $nextAll = new Date("2020-02-02");

        $this->assertEquals($nextDay, (clone $date)->addDays(1));
        $this->assertEquals($nextMonth, (clone $date)->addDays(0, 1));
        $this->assertEquals($nextYear, (clone $date)->addDays(0, 0, 1));
        $this->assertEquals($nextAll, (clone $date)->addDays(1, 1, 1));
    }

    public function testDiffingDates()
    {
        $first = new Date("2019-01-01");
        $last = new Date("2019-01-07");

        $diff = $first->diffDays($last);

        $this->assertEquals(6, $diff);
    }
}
